/* Simple AJAX Code-Kit (SACK) v1.5 */
/* ©2005 Gregory Wild-Smith */
/* www.twilightuniverse.com */
/* Software licenced under a modified X11 licence,
   see documentation or authors website for more details */

function sack(file){
	this.xmlhttp = null;
	this.AjaxFailedAlert = "Your browser does not support the enhanced functionality of this website, and therefore you will have an experience that differs from the intended one.\n";
	
	this.callInProgress = function() {
		switch ( this.xmlhttp.readyState ) {
			case 1: case 2: case 3:
				return true;
			break;

			// Case 4 and 0
			default:
				return false;
			break;
		}
	};

	this.resetData = function() {
		this.method = "POST";
  		this.URLString = "";
  		this.encodeURIString = true;
  		this.execute = false;
  		this.element = null;
		this.elementObj = null;
		this.requestFile = file;
		this.vars = new Object();
		this.responseStatus = new Array(2);
  	};
	
	this.resetFunctions = function() {
  		this.onLoading = function() { };
  		this.onLoaded = function() { };
  		this.onInteractive = function() { };
  		this.onCompletion = function() { };
  		this.onError = function() { };
	};
	
	this.reset = function() {
		this.resetFunctions();
		this.resetData();
	};
	
	this.reset(); /* setup defaults, using the same method that could reset them later. */
	
	this.createAJAX = function() {
		try {
			this.xmlhttp = new ActiveXObject("Msxml2.XMLHTTP");
		} catch (e) {
			try {
				this.xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");
			} catch (err) {
				this.xmlhttp = null;
			}
		}
		if(!this.xmlhttp && typeof XMLHttpRequest != "undefined")
			this.xmlhttp = new XMLHttpRequest();
		if (!this.xmlhttp){
			this.failed = true; 
		}
	};

	this.setVar = function(name, value){
		this.vars[name] = Array(value, false);
	};
	
	this.encVar = function(name, value, returnvars){
		if(true == returnvars){
			return Array(encodeURIComponent(name), encodeURIComponent(value));
		} else {
			this.vars[encodeURIComponent(name)] = Array(encodeURIComponent(value), true);
		}
	};
	
	this.processURLString = function(string, encode){
		varArray = string.split('&');
		for (i = 0; i < varArray.length; i++){
			urlVars = varArray[i].split('=');
			if (urlVars[0].indexOf('amp;') != -1){
				urlVars[0] = urlVars[0].substring(4);
			}
			if (true == encode){
				this.encVar(urlVars[0],urlVars[1]);
			} else {
				this.setVar(urlVars[0],urlVars[1]);
			}
		}
	};
	
	this.createURLString = function(urlstring){ // near done! 
		var timeval = new Date().getTime();
		
		if (this.encodeURIString && this.URLString){
			this.processURLString(this.URLString, true);
		}
		if (urlstring){
			if (this.URLString.length){
				this.URLString = this.URLString + "&" + urlstring; 
			} else {
				this.URLString = urlstring; 
			}
		}

		this.setVar("rndval", timeval); //prevents caching of URLString.

		for (key in this.vars){ //First Loop: Vars are encoded if needed.
    			if (false == this.vars[key][1] && true == this.encodeURIString){
				var encoded = this.encVar(key, this.vars[key][0], true);
				delete this.vars[key];
				this.vars[encoded[0]] = Array(encoded[1], true);
    			}
		}
		var i = 0;
		for (key in this.vars){ //Second Loop: Creates URLString from vars.
			if (i != 0){
    				this.URLString += "&" + key + "=" + this.vars[key][0];
    			} else {
    				this.URLString += key + "=" + this.vars[key][0];
    			}
    			i++;
		}
	};
	
	this.runResponse = function(){
		eval(this.response);
	};
	
	this.runAJAX = function(urlstring){
		if(this.failed && this.AjaxFailedAlert){ 
			alert(this.AjaxFailedAlert); 
		} else {
			this.createURLString(urlstring);
			if (this.element) { this.elementObj = document.getElementById(this.element); }
			if (this.xmlhttp) {
				var self = this;
				if (this.method == "GET") {
					var totalurlstring = this.requestFile + "?" + this.URLString;
					this.xmlhttp.open(this.method, totalurlstring, true);
				} else {
					this.xmlhttp.open(this.method, this.requestFile, true);
				}
				if (this.method == "POST"){
  					try {
						this.xmlhttp.setRequestHeader('Content-Type','application/x-www-form-urlencoded')  
					} catch (e) {}
				}

				this.xmlhttp.onreadystatechange = function() {
					switch (self.xmlhttp.readyState){
						case 1:
							self.onLoading();
						break;
						case 2:
							self.onLoaded();
						break;
						case 3:
							self.onInteractive();
						break;
						case 4:
							self.response = self.xmlhttp.responseText;
							self.responseXML = self.xmlhttp.responseXML;
							self.responseStatus[0] = self.xmlhttp.status;
							self.responseStatus[1] = self.xmlhttp.statusText;
							if(self.execute){ self.runResponse(); }
							if (self.elementObj) {
								var elemNodeName = self.elementObj.nodeName.toLowerCase();
								if (elemNodeName == "input" || elemNodeName == "select" || elemNodeName == "option" || elemNodeName == "textarea"){
									self.elementObj.value = self.response;
								} else {
									self.elementObj.innerHTML = self.response;
								}
							}
							if ("200" == self.responseStatus[0]){
								self.onCompletion();
							} else {
								self.onError();
							}
							self.URLString = "";
						break;
					}
				};
				this.xmlhttp.send(this.URLString);
			}
		}
	};
this.createAJAX();
}